;/*******************************/;
;/* Demo 7-SEG Scan For ET-EXP4 */;
;/* Files Name  : LAB1-EX2.ASM  */;
;/* CPU Control : MCS51 Family  */;
;/* Assembler   : SXA51.EXE     */;
;/*   (Scan 7-Segment "0123")   */;
;/*******************************/;
;
;/* Port For Control 7-Segment
PORT_ROW    EQU     P1                  ; Data Drive 7 Segment
PORT_COL    EQU     P0                  ; Port-0 = Colum Scan

            ORG     20H
DSP_BUFF:   DS      4                   ; Display buffer 4 Byte
COL_SCAN:   DS      1                   ; Colum Buffer Data Scan
DIG_SCAN:   DS      1                   ; 7-Segment Digit Count
STACK:      DS      32                  ; 32 Byte Stack

            ORG     0000H               ; Start Monitor
MAIN:       MOV     SP,#STACK
            MOV     DSP_BUFF+0,#0       ; Digit1 = 0
            MOV     DSP_BUFF+1,#1       ; Digit2 = 1
            MOV     DSP_BUFF+2,#2       ; Digit3 = 2
            MOV     DSP_BUFF+3,#3       ; Digit4 = 3
            ;
SCAN7SEG:   MOV     R0,#DSP_BUFF        ; Display Buffer Code
            MOV     COL_SCAN,#0         ; Colum Multiplex Code
            MOV     DIG_SCAN,#4         ; 4 Digit Counter Scan
            ;
SCANSEG1:   MOV     A,@R0               ; Get Left Digit 7-Segment
            MOV     DPTR,#TAB_SEG
            MOVC    A,@A+DPTR           ; Convert to 7-Segment Code
            MOV     PORT_ROW,A
            MOV     PORT_COL,COL_SCAN   ; Active Colum Scan
            ;
            MOV     R2,#2               ; Scan Delay Counter
SCANSEG2:   MOV     R3,#250
            DJNZ    R3,$
            DJNZ    R2,SCANSEG2
            ;
            INC     R0                  ; Next Row Buffer
            INC     COL_SCAN
            DJNZ    DIG_SCAN,SCANSEG1   ; Loop Until Row Complete (4-Seg)
            LJMP    SCAN7SEG            ; Repeat Scan Continue

;/************************/;
;/* Table 7-Segment Code */;
;/*   Dp A B C D E F G   */;
;/*   D7............D0   */;
;/************************/;
;
TAB_SEG:    DB      03FH,006H,05BH,04FH ; 0 1 2 3
            DB      066H,06DH,07DH,007H ; 4 5 6 7
            DB      07FH,06FH,077H,07CH ; 8 9 A B
            DB      039H,05EH,079H,071H ; C D E F

            END


