;/*******************************/;
;/* Demo Speaker For ET-EXP4    */;
;/* Files Name  : LAB5-EX5.ASM  */;
;/* CPU Control : MCS-51 Family */;
;/* Assembler   : SXA51.EXE     */;
;/* -Timer Run  : Interupt Mode */;
;/* (Generate Music Sound Note) */;
;/*******************************/;
;
;/* Port For Control Speaker
PORT_OUT    EQU     P1                  ; Step,Relay,Spk
SPEAKER     EQU     P1.5                ; Port.5 = Speaker Control

            ORG     20H                 ; Internal RAM of CPU
FLAG_BUF:   DS      1                   ; Flag Status
SONG_PTR:   DS      1                   ; Index For Get Delay
NOTE_PTR:   DS      1
TIME_PTR:   DS      1
NOTE_BUF:   DS      2                   ; Note Buffer
TIME_BUF:   DS      2                   ; Delay Buffer
SONG_CNT:   DS      1
TEST_CNT:   DS      1

UPDATE      EQU     FLAG_BUF.0          ; Flag Over Flow Status

            ORG     0000H               ; Reset Vector of CPU
            LJMP    MAIN
            ORG     000BH               ; Timer0 Vector Interupt
            LJMP    TIMER_INT

MAIN:       MOV     SP,#128-32          ; Stack = 32 Byte Internal RAM
            MOV     PORT_OUT,#0         ; OFF Step & Relay Bit
            CLR     UPDATE
            MOV     TMOD,#00000001B     ; Timer0 Mode1
            SETB    ET0                 ; Enable Timer0 Interupt
            CLR     EA                  ; Disable Global Interupt
            ;
NEW_SONG:   MOV     SONG_PTR,#0         ; Strat Note
            ;
STR_SONG:   MOV     DPTR,#TAB_SONG
            MOV     A,SONG_PTR
            MOV     B,#2                ; 2-Byte : 1-Note
            MUL     AB                  ; AxB = BA
            ADD     A,DPL               ; Update DPTR
            MOV     DPL,A
            MOV     A,B
            ADDC    A,DPH
            MOV     DPH,A
            ;
            CLR     A
            MOVC    A,@A+DPTR           ; Get Note of Song
            CJNE    A,#0FFH,SONG_OK     ; Check Last Note
            SJMP    NEW_SONG
            ;
SONG_OK:    MOV     NOTE_PTR,A          ; SONG_PTR => NOTE_PTR
            INC     DPTR
            CLR     A
            MOVC    A,@A+DPTR           ; Get Time of Song
            MOV     TIME_PTR,A          ; SONG_PTR => TIME_PTR
            ;
            LCALL   GET_NOTE            ; Get NOTE_PTR => NOTE_BUF
            LCALL   GET_TIME            ; Get TIME_PTR => TIME_BUF
            MOV     TH0,NOTE_BUF+0
            MOV     TL0,NOTE_BUF+1
            CLR     UPDATE
            CLR     SPEAKER
            SETB    TR0                 ; Sound on
            SETB    EA
            ;
SONG0:      MOV     TIME_BUF+1,#4
SONG1:      NOP
            JNB     UPDATE,SONG1
            CLR     UPDATE
            DJNZ    TIME_BUF+1,SONG1
            DJNZ    TIME_BUF+0,SONG0
            ;
            CLR     TR0                 ; Sound off
            CLR     EA
            SETB    SPEAKER

            MOV     R2,#1
SONG2:      MOV     R3,#15
SONG3:      MOV     R4,#0
SONG4:      NOP
            NOP
            DJNZ    R4,SONG4
            DJNZ    R3,SONG3
            DJNZ    R2,SONG2
            INC     SONG_PTR            ; Next Note
            SJMP    STR_SONG            ; Restart Song

;/***********************/;
;/* Get Note From Table */;
;/* Input : NOTE_PTR    */;
;/* Output: NOTE_BUF0,1 */;
;/***********************/;
;
GET_NOTE:   PUSH    DPH
            PUSH    DPL
            PUSH    B
            PUSH    ACC
            ;
            MOV     DPTR,#TAB_NOTE
            MOV     A,NOTE_PTR
            MOV     B,#2                ; 2-Byte : 1-Note
            MUL     AB                  ; AxB = BA
            ADD     A,DPL               ; Update DPTR
            MOV     DPL,A
            MOV     A,B
            ADDC    A,DPH
            MOV     DPH,A
            ;
            CLR     A
            MOVC    A,@A+DPTR
            MOV     NOTE_BUF+0,A
            INC     DPTR
            CLR     A
            MOVC    A,@A+DPTR
            MOV     NOTE_BUF+1,A
            ;
            POP     ACC
            POP     B
            POP     DPL
            POP     DPH
            RET

;/***********************/;
;/* Get Delay From Table*/;
;/* Input  : TIME_PTR   */;
;/* Output : TIME_BUF   */;
;/***********************/;
;
GET_TIME:   PUSH    DPH
            PUSH    DPL
            PUSH    ACC
            ;
            MOV     DPTR,#TAB_DLY
            MOV     A,TIME_PTR
            MOVC    A,@A+DPTR
            MOV     TIME_BUF,A
            ;
            POP     ACC
            POP     DPL
            POP     DPH
            RET

;/*****************************/;
;/* Timer 0 Interrupt Service */;
;/* Auto Reload on Interrupt  */;
;/*****************************/;
;
TIMER_INT:  MOV     TH0,NOTE_BUF+0
            MOV     TL0,NOTE_BUF+1
            CPL     SPEAKER
            SETB    UPDATE
END_TIME:   RETI

;/***********************************/;
;/* Table PWM For MCS51 Timer Mode1 */;
;/* X-TAL 11.059 MHz : 16-Bit Timer */;
;/* (Value For TH0,TL0 = 1/2 Freq.) */;
;/***********************************/;
;
TAB_NOTE:   DB      0FFH,0FEH               ;No Sound
            DB      0F9H,01EH               ;C  (261.669)  Octave4
            DB      0F9H,081H               ;C# (277.256)
            DB      0F9H,0DEH               ;D  (293.690)
            DB      0FAH,036H               ;D# (311.141)
            DB      0FAH,089H               ;E  (329.614)
            DB      0FAH,0D8H               ;F  (349.355)
            DB      0FBH,022H               ;F# (370.120)
            DB      0FBH,067H               ;G  (391.836)
            DB      0FBH,0A9H               ;G# (415.135)
            DB      0FBH,0E8H               ;A  (440.114)
            DB      0FCH,022H               ;A# (465.925)
            DB      0FCH,05AH               ;B  (493.890)
            ;
            DB      0FCH,08EH               ;C  (523.042)  Octave5
            DB      0FCH,0C0H               ;C# (554.512)
            DB      0FCH,0EEH               ;D  (587.006)
            DB      0FDH,01AH               ;D# (621.862)
            DB      0FDH,044H               ;E  (659.228)
            DB      0FDH,06BH               ;F  (698.182)
            DB      0FDH,090H               ;F# (739.647)
            DB      0FDH,0B3H               ;G  (783.674)
            DB      0FDH,0D4H               ;G# (830.270)
            DB      0FDH,0F3H               ;A  (879.389)
            DB      0FEH,011H               ;A# (932.793)
            DB      0FEH,02CH               ;B  (986.724)


TAB_DLY:    DB     001,023,063,127,255

;/********************/;
;/* Table of Pointer */;
;/* For Note & Delay */;
;/********************/;
;
TAB_SONG:   DB      00,4,01,2,02,2,03,2
            DB      04,2,05,2,06,2,07,2
            DB      08,2,09,2,10,2,11,2
            DB      12,2,00,4,00,4,00,4
            DB      13,2,14,2,15,2,16,2
            DB      17,2,18,2,19,2,20,2
            DB      21,2,22,2,23,2,24,2
            DB      0FFH                    ; Last Note

            END

