;/*******************************/;
;/* Demo DC Motor  For ET-EXP4  */;
;/* Files Name  : LAB9-EX2.ASM  */;
;/* CPU Control : MCS51 Family  */;
;/* Assembler   : SXA51.EXE     */;
;/*   (Auto Control DC Motor)   */;
;/*******************************/;
;
PORT_LED    EQU     P0                      ; Port LED Status
;
;/* Port For Control DAC
PORT_DAC    EQU     P1                      ; DAC Output
;
;/* Port Control Motor
PORT_MTR    EQU     P2                      ; DC Motor Control

SPEED_MAX   EQU     20                      ; Speed 20 Round : 1 Second

            ORG     20H
FLAG_BUF:   DS      1                       ; Flag Status
SPEED:      DS      1                       ; Speed Motor
TIME_CNT:   DS      1                       ; 1-Second Count
SPEED_CNT:  DS      1                       ; Speed : 1second Count
STACK:      DS      32                      ; 32 Byte Stack
;                                           ; Stack 32 Byte
AUTO_STOP   EQU     FLAG_BUF.0

            ORG     0000H                   ; Reset Vector of CPU
            LJMP    MAIN
            ORG     000BH                   ; Timer0 Vector Interupt
            LJMP    TIME0_INT
            ;
MAIN:       MOV     SP,#STACK               ; Stack = 32 Byte Internal RAM
            MOV     PORT_MTR,#0FFH
            MOV     PORT_LED,#00H
            MOV     TMOD,#00010001B         ; Timer1 & Timer0 Mode1(16-Bit)
            SETB    ET0                     ; Enable Timer0 Interupt
            SETB    EA                      ; Enable Global Interupt
            ;
            SETB    PORT_MTR.4              ; Direction Motor
            CLR     PORT_MTR.5
            MOV     SPEED,#0FFH
            MOV     PORT_DAC,SPEED          ; Start Motor
            MOV     R2,#250
STRT_MTR:   MOV     R3,#0FFH
            DJNZ    R3,$
            DJNZ    R2,STRT_MTR
            MOV     SPEED,#7FH              ; Speed 50%
            ;
            ;/* Check Speed : 1 Second
CTL_MTR0:   MOV     TH0,#0DBH               ; Timer-0 = 10 mSec Period
            MOV     TL0,#0FFH
            MOV     TIME_CNT,#100           ; 1 Second Time Count
            MOV     SPEED_CNT,#00H
            CLR     AUTO_STOP
            SETB    TR0                     ; Start Timer0 Count
            ;
CTL_MTR1:   JB      AUTO_STOP,CTL_MTR4
            JNB     PORT_MTR.0,CTL_MTR2     ; Sensor ON Jump
            SJMP    CTL_MTR1                ; Wait Sensor-ON
            ;
CTL_MTR2:   INC     SPEED_CNT               ; INC Counter
CTL_MTR3:   JB      AUTO_STOP,CTL_MTR4
            JB      PORT_MTR.0,CTL_MTR1     ; Sensor OFF Jump
            SJMP    CTL_MTR3                ; Wait Sensor-OFF

CTL_MTR4:   MOV     A,SPEED_CNT
            CJNE    A,#SPEED_MAX,CTL_MTR5
            MOV     PORT_LED,#00011000B     ; Speed OK Status
            SJMP    CTL_MTR0                ; Speed OK
            ;
CTL_MTR5:   JC      CTL_MTR7                ; Lessthan Speed MAX
            MOV     PORT_LED,#11000000B     ; Speed Over Status
            MOV     A,SPEED
            CJNE    A,#00H,CTL_MTR6
            SJMP    CTL_MTR0                ; MIN Adjust
            ;
CTL_MTR6:   DEC     SPEED                   ; Speed Over Limit
            MOV     PORT_DAC,SPEED
            SJMP    CTL_MTR0
            ;
CTL_MTR7:   MOV     PORT_LED,#00000011B     ; Speed Under Status
            MOV     A,SPEED
            CJNE    A,#0FFH,CTL_MTR8
            SJMP    CTL_MTR0                ; MAX Adjust
            ;
CTL_MTR8:   INC     SPEED                   ; Speed Under Limit
            MOV     PORT_DAC,SPEED
            SJMP    CTL_MTR0

;/******************************/;
;/* Timer 0 : 1 Second Service */;
;/*    Interupt Every 10 mSec  */;
;/* Auto Reload Every 1 Second */;
;/* Define Time By : TIME_CNT  */;
;/******************************/;
;
TIME0_INT:  MOV     TH0,#0DBH               ; 10 mSec Period Auto Reload
            MOV     TL0,#0FFH
            DJNZ    TIME_CNT,END_TIME0      ; Check Time = 1-Second ?
            CLR     TR0                     ; Stop Timer0 Count
            SETB    AUTO_STOP
END_TIME0:  RETI

            END

