;/*******************************/;
;/* Demo Speaker For ET-EXP4    */;
;/* Files Name  : LAB5-EX4.ASM  */;
;/* CPU Control : 68HC811E2     */;
;/* Assembler   : AS11NEW.EXE   */;
;/*   (Beep Sound on Speaker)   */;
;/*******************************/;
;
;/* Port For Control Speaker
PORT_OUT    EQU     $1004               ; Step,Relay,Spk (Port-B)
SPEAKER     EQU     %00100000           ; Port.5 = Speaker Control

            ORG     $F800               ; Start Monitor of 68HC811E2
MAIN        LDS     #$FF                ; Stack = Last Internal RAM
            LDX     #PORT_OUT           ; Port Control Speaker
            CLR     PORT_OUT            ; OFF Step & Relay Bit
            ;
LOOP_NEW    LDAA    #100                ; Duration Beep
BEEP_ON     BSET    0,X SPEAKER         ; ON Speaker
            LDAB    #200
DLY_ON      DECB
            BNE     DLY_ON
            BCLR    0,X SPEAKER         ; OFF Speaker
            LDAB    #200
DLY_OFF     DECB
            BNE     DLY_OFF
            DECA
            BNE     BEEP_ON
            JSR     DELAY
            BRA     LOOP_NEW

;/**********************/;
;/* Delay Time 1Second */;
;/**********************/;
;
DELAY       PSHB                        ; Save Register
            PSHX
            LDAB    #100                ; 10mS x 100 = 1Second
DLY1        LDX     #$0D06              ; 10mS Count
DLY2        DEX
            BNE     DLY2
            DECB
            BNE     DLY1
            PULX                        ; Restore Register
            PULB
            RTS

            ORG     $FFFE               ; Reset Vector
            FDB     MAIN

            END

